SystemOrganization addCategory: #'GMF-UMLModel'!

Object subclass: #DataForGenerator
	instanceVariableNames: 'UMLModel dataForGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!DataForGenerator class methodsFor: 'instance creation' stamp: 'volosmat 7/20/2013 20:35'!
UMLModel: xUMLModel
	 ^(super new initialize )
		UMLModel: xUMLModel;
		createAll;
		yourself.! !

!DataForGenerator methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 19:46'!
UMLModel
	^ UMLModel! !

!DataForGenerator methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 19:46'!
UMLModel: anObject
	UMLModel := anObject! !

!DataForGenerator methodsFor: 'private' stamp: 'volosmat 12/11/2013 23:57'!
createAll
	| class attr method |
	UMLModel
		do: [:a | 
			class := self createClass: a.
			a attributes
				do: [:b | 
					attr := self createAttribut: b.
					class addVariable: attr]. 
			a methods
				do: [:b | 
					method := self createMethod: b.
					class addMethod: method].
			a parent notNil
				ifTrue: [class
						parent: (self searchClass: a parent name)].
			dataForGenerator addClass: class].
	UMLModel
		do: [:a | a compositions
				do: [:b | b start name = a name
						ifTrue: [self createAssociation: b]]]! !

!DataForGenerator methodsFor: 'private' stamp: 'MatusVolosin 7/24/2013 16:10'!
createAssociation: xComposition
	| attrE tmpE attrS tmpS GAssociation |
	"jednostranna"
	xComposition nameEnd notNil & xComposition nameStart isNil
		ifTrue: [ attrE := self createAttribut: xComposition start: false.
				 tmpE := self searchClass: xComposition end name.
				 tmpE addVariable: attrE].
	xComposition nameStart notNil & xComposition nameEnd isNil
		ifTrue: [attrS := self createAttribut: xComposition start: true.
				tmpS := self searchClass: xComposition start name.
				tmpS addVariable: attrS].
	"obojstranna"
	xComposition nameStart notNil & xComposition nameEnd notNil
		ifTrue: [attrE := self createAttribut: xComposition start: false.	
				tmpE := self searchClass: xComposition end name.
				attrS := self createAttribut: xComposition start: true.
				tmpS := self searchClass: xComposition start name.
				tmpS addVariable: attrS.
				tmpE addVariable: attrE.
				GAssociation := GeneratedAssociation
								newLeft: tmpS
								Var: attrS
								RIght: tmpE
								Var: attrE.
				tmpS association: GAssociation.
				tmpE association: GAssociation ].! !

!DataForGenerator methodsFor: 'private' stamp: 'MatusVolosin 7/21/2013 11:21'!
createAttribut: xAttribut
	| attr |
	attr := GeneratedEOCVariable newName: xAttribut name Instance: xAttribut instance.
	xAttribut quantity ~= 1 & (xAttribut quantity ~= '1') & (xAttribut quantity ~= '0') & (xAttribut quantity ~= 0)
		ifTrue: [attr collection: 'OrderedCollection']. 
	^ attr! !

!DataForGenerator methodsFor: 'private' stamp: 'MatusVolosin 7/21/2013 11:22'!
createAttribut: xAssociation start: xStart 
	| attr |
	xStart
		ifTrue: [attr := GeneratedEOCVariable newName: xAssociation nameStart.
			xAssociation startMultiplicity ~= 1 & (xAssociation startMultiplicity ~= '1') & (xAssociation startMultiplicity ~= '0') & (xAssociation startMultiplicity ~= 0)
				ifTrue: [attr collection: 'OrderedCollection']]; 
		
		ifFalse: [attr := GeneratedEOCVariable newName: xAssociation nameEnd.
			xAssociation endMultiplicity ~= 1 & (xAssociation endMultiplicity ~= '1') & (xAssociation endMultiplicity ~= '0') & (xAssociation endMultiplicity ~= 0)
				ifTrue: [attr collection: 'OrderedCollection']].
	^ attr! !

!DataForGenerator methodsFor: 'private' stamp: 'volosmat 7/20/2013 21:08'!
createClass: xElement
	^GeneratedClass newName: xElement name.! !

!DataForGenerator methodsFor: 'private' stamp: 'volosmat 7/20/2013 22:03'!
createMethod: xMethod
	| method |
	method := GeneratedEOCMethod
				newName: xMethod name
				Instance: xMethod instance 
				Abstract: xMethod abstract.
	xMethod parameters
		do: [:c | method
				addArgument: (GeneratedEOCVariable newName: c)].
	^ method.! !

!DataForGenerator methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 19:45'!
dataForGenerator
	^ dataForGenerator! !

!DataForGenerator methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 19:45'!
dataForGenerator: anObject
	dataForGenerator := anObject! !

!DataForGenerator methodsFor: 'initialize-release' stamp: 'volosmat 7/20/2013 22:33'!
initialize

	dataForGenerator		 := GeneratedAll new.
			
	^ self! !

!DataForGenerator methodsFor: 'search' stamp: 'volosmat 7/20/2013 21:40'!
searchClass: xName  
      "najde triedu v datach pre generator podla mena"
	dataForGenerator classes do: [ :b | ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

Object subclass: #Transform
	instanceVariableNames: 'element elementTransformed transformClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!Transform class methodsFor: 'instance creation' stamp: 'MatusVolosin 10/12/2013 19:57'!
element: xElement transformClass: xTransformClass
	 ^(super new initialize )
		element: xElement;
		transformClass: xTransformClass;
		transform;
		yourself.
		! !

!Transform methodsFor: 'accessing' stamp: 'MatusVolosin 7/21/2013 15:42'!
element
	^ element! !

!Transform methodsFor: 'accessing' stamp: 'MatusVolosin 7/21/2013 15:42'!
element: anObject
	element := anObject! !

!Transform methodsFor: 'accessing' stamp: 'MatusVolosin 7/21/2013 15:42'!
elementTransformed
	^ elementTransformed! !

!Transform methodsFor: 'accessing' stamp: 'MatusVolosin 7/21/2013 15:42'!
elementTransformed: anObject
	elementTransformed := anObject! !

!Transform methodsFor: 'search' stamp: 'MatusVolosin 10/15/2013 20:55'!
searchElement: xClass name: xName
      "najdenie elementu v datach spacifickeho typu xClass a name xName"
	transformClass dataToTransform do: [ :b | b transformed not & ( b class = xClass ) & ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!Transform methodsFor: 'search' stamp: 'MatusVolosin 10/15/2013 20:54'!
searchTransformedElement: xName
      "najdenie elementu v uz transformovanych elementoch name xName"
	transformClass transformedElements do: [ :b | ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!Transform methodsFor: 'methods' stamp: 'MatusVolosin 10/15/2013 21:19'!
transform
	| package class |
	
	package := PackageInfo named: 'GMF-UMLModel'.
	( package classes
		anySatisfy: [:b | (b name asString) = ( 'Transform', element class asString ) ] )
		ifTrue: [ class := Compiler evaluate: 'Transform', element class asString,' new'. 
				 class element: element.
				 class transformClass: transformClass. 
				 class transform. ];
		ifFalse: [ TransformElement element: element transformClass: transformClass. ].! !

!Transform methodsFor: 'accessing' stamp: 'MatusVolosin 10/12/2013 19:35'!
transformClass
	^ transformClass! !

!Transform methodsFor: 'accessing' stamp: 'MatusVolosin 10/12/2013 19:35'!
transformClass: anObject
	transformClass := anObject! !

Transform subclass: #TransformElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformElement methodsFor: 'private' stamp: 'volosmat 12/11/2013 23:58'!
transform
	| tmp attributs methods xParent |
	"transformovanie elementu z onto uml do uml"
	tmp := self searchTransformedElement: element name.
	( tmp notNil )
		ifTrue: [ elementTransformed := tmp. 
				 ^tmp ].
		
	( element parent size = 0 )
		ifTrue: [ tmp := UMLElement name: element name abstract: element abstract. ].
	( element parent size = 1 )
		ifTrue: [ 
			Transform element: element parent first transformClass: transformClass.
			xParent := self searchTransformedElement: element parent first name.
			tmp := UMLElement name: element name parent: xParent abstract: element abstract disjoint: element disjoint. 
			      ].
	( element parent size > 1 )
		ifTrue: [ "TODO vicenasobna dedicnost"  ].
	
	( element methods size > 0 )
		ifTrue: [ methods := element methods copy.
				 tmp methods: methods.  ].
	( element attributes size > 0 )
		ifTrue: [ attributs := element attributes copy.
				 tmp attributes: attributs. ].
			
	elementTransformed := tmp.
	element transformed: true.
	transformClass transformedElements add: tmp.
	
	( element associations size > 0 )
		ifTrue: [ TransformAssociation element: element UMLElement: tmp transformClass: self. ].
	
! !

Transform subclass: #TransformPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformPhase methodsFor: 'private' stamp: 'volosmat 12/11/2013 23:58'!
transform
	| methods attributs phaseAttr tmp xParent |
	element parent size = 1
		ifTrue: [Transform element: element parent first transformClass: transformClass.
			xParent := self searchTransformedElement: element parent first name.
			tmp := UMLElement name: element name abstract: element abstract.
			xParent XOR add: tmp];
		
		ifFalse: [].
	element methods size > 0
		ifTrue: [methods := element methods copy.
			tmp methods: methods].
	element attributes size > 0
		ifTrue: [attributs := element attributes copy.
			tmp attributes: attributs].
	phaseAttr := Attribute
				name: 'phase'
				dataType: Phase
				quantity: 1.
	( xParent attributes allSatisfy: [ :a | a name ~= 'phase' ] )
		ifTrue: [ xParent attributes add: phaseAttr. ].
	
	elementTransformed := tmp.
	element transformed: true.
	transformClass transformedElements add: tmp.
	element associations size > 0
		ifTrue: [TransformAssociation
				element: element
				UMLElement: tmp
				transformClass: self]! !

Transform subclass: #TransformRole
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformRole methodsFor: 'private' stamp: 'volosmat 12/11/2013 23:58'!
transform
	| tmp xParent methods attributs |
	( element parent size = 1 )
		ifTrue: [ Transform element: element parent first transformClass: transformClass.
				 xParent := self searchTransformedElement: element parent first name.
			       tmp := UMLElement name: element name parent: xParent isAbstract: element isAbstract isDisjoint: element isDisjoint. ];
		ifFalse: [ "TODO vicenasobna dedicnost" ].
	
	( element methods size > 0 )
		ifTrue: [ methods := element methods copy.
				 tmp methods: methods.  ].
	( element attributes size > 0 )
		ifTrue: [ attributs := element attributes copy.
				 tmp attributes: attributs. ].
	
	element transformed: true.
	transformClass transformedElements add: tmp.
	
	( element associations size > 0 )
		ifTrue: [ TransformAssociation element: element UMLElement: tmp transformClass: self. ].
		! !

Object subclass: #TransformAssociation
	instanceVariableNames: 'transformClass element UMLElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformAssociation class methodsFor: 'instance creation' stamp: 'volosmat 7/17/2013 11:36'!
element: xElement UMLElement: xUMLElement transformClass: xTransformClass
	 ^(super new initialize )
		element: xElement;
		transformClass: xTransformClass;	
		UMLElement: xUMLElement;
		transformAssociation;
		yourself.! !

!TransformAssociation methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 11:34'!
UMLElement
	^ UMLElement! !

!TransformAssociation methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 11:34'!
UMLElement: anObject
	UMLElement := anObject! !

!TransformAssociation methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 11:34'!
element
	^ element! !

!TransformAssociation methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 11:34'!
element: anObject
	element := anObject! !

!TransformAssociation methodsFor: 'private' stamp: 'volosmat 7/19/2013 13:39'!
isReverse: xAssociation 
	"funkce zisti ci je asociace reversni tj. obojstranna"
	| cnt tmp |
	cnt := 0.
	element associations
		do: [:b | ( b end = xAssociation start ) & ( b start = xAssociation end ) & (b name ~= xAssociation name)
				ifTrue: [cnt := cnt + 1.
						tmp := b]].
	cnt = 0
		ifTrue: [^ false]. 
	cnt = 1
		ifTrue: [ tmp transformed: true. ^ tmp].
	cnt > 1
		ifTrue: [ ^true ]! !

!TransformAssociation methodsFor: 'private' stamp: 'volosmat 7/19/2013 13:24'!
transformAssociation
	| nameEnd reverse composition tmpStart tmpEnd tmpStartElem tmpEndElem |
	element associations
		do: [:a | a transformed = false & (element name = a start name)
				ifTrue: [a transformed: true. 
					reverse := self isReverse: a.
					reverse = true
						ifTrue: [nameEnd := nil];
						
						ifFalse: [nameEnd := reverse name].
					reverse = false
						ifTrue: [nameEnd := a name].
					composition := UMLCompositions
								nameStart: a name
								nameEnd: nameEnd
								start: a start
								startMultiplicity: a startQuantity
								end: a end
								endMultiplicity: a endQuantity.
					UMLElement compositions add: composition.
					tmpStart := self transformClass searchTransformedElement: a start name.
					tmpEnd := self transformClass searchTransformedElement: a end name.
					tmpStart isNil
						ifTrue: [tmpStartElem := self transformClass searchElement: a start class name: a start name.
							TransformElement element: tmpStartElem transformClass: transformClass transformClass].
					tmpEnd isNil
						ifTrue: [tmpEndElem := self transformClass searchElement: a end class name: a end name.
							TransformElement element: tmpEndElem transformClass: transformClass transformClass]]]! !

!TransformAssociation methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 11:10'!
transformClass
	^ transformClass! !

!TransformAssociation methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 11:10'!
transformClass: anObject
	transformClass := anObject! !

Object subclass: #TransformToUML
	instanceVariableNames: 'dataToTransform element transformedElements dataForGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformToUML class methodsFor: 'instance creation' stamp: 'Anonymous 5/8/2013 18:16'!
dataToTransform: xData

	^(super new initialize)
		dataToTransform: xData;
		yourself! !

!TransformToUML methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 22:51'!
dataForGenerator
	^ dataForGenerator! !

!TransformToUML methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 22:51'!
dataForGenerator: anObject
	dataForGenerator := anObject! !

!TransformToUML methodsFor: 'accessing' stamp: 'volosmat 7/20/2013 22:54'!
dataToTransform
	^ dataToTransform! !

!TransformToUML methodsFor: 'accessing' stamp: 'volosmat 11/28/2013 19:23'!
dataToTransform: anObject 
	dataToTransform := anObject.! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
element
	^ element! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
element: anObject
	element := anObject! !

!TransformToUML methodsFor: 'initialize-release' stamp: 'volosmat 11/27/2013 20:44'!
initialize

	transformedElements	 := OrderedCollection new.
	dataForGenerator		 := GeneratedAll new.
			
	^ self! !

!TransformToUML methodsFor: 'private' stamp: 'volosmat 7/16/2013 14:23'!
isTransformed
	"prejdenie celej kolekce dat a zistenie ci su vsetky elementy prevedene"
	^dataToTransform allSatisfy: [:b | b transformed ].! !

!TransformToUML methodsFor: 'private' stamp: 'volosmat 7/16/2013 14:21'!
readNextElement
	"nacitanie noveho elementu v poradi z data na transform"
	element := dataToTransform detect: [ :b | b transformed not ].! !

!TransformToUML methodsFor: 'search' stamp: 'volosmat 7/17/2013 11:57'!
searchElement: xClass 
      "najdenie elementu v datach spacifickeho typu xClass"
	dataToTransform do: [ :b | b transformed not & ( b class = xClass ) ifTrue: [ element := b. ^true. ] ].
	^false.! !

!TransformToUML methodsFor: 'methods' stamp: 'volosmat 11/28/2013 19:23'!
transformAll
	"prevedenie vsetkych elementov najprv Category a kind a potom ostatne"
	dataToTransform 
		do: [:each | each transformed: false].
		
	[ self searchElement: Category ] whileTrue: [ 
 	  	Transform element: element transformClass: self.	  
	].
	
	[ self searchElement: Kind ] whileTrue: [ 
 	  	Transform element: element transformClass: self.  
	].


	[self isTransformed] whileFalse: [
		self readNextElement.
		Transform element: element transformClass: self. ]! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
transformedElements
	^ transformedElements! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
transformedElements: anObject
	transformedElements := anObject! !

Object subclass: #UMLCompositions
	instanceVariableNames: 'start end nameStart nameEnd startMultiplicity endMultiplicity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 7/17/2013 12:28'!
nameStart: xNameStart nameEnd: xNameEnd start: xStart end: xEnd endMultiplicity: xEndMulti 
	^ super new initialize nameStart: xNameStart;
		 nameEnd: xNameEnd;
		 start: xStart;
		 end: xEnd;
		 endMultiplicity: xEndMulti;
		 yourself! !

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 7/17/2013 12:30'!
nameStart: xNameStart nameEnd: xNameEnd start: xStart startMultiplicity: xStartMulti end: xEnd endMultiplicity: xEndMulti
	^ super new initialize 
		 nameStart: xNameStart;
	    	 nameEnd: xNameEnd;
		 start: xStart;
		 end: xEnd;
		 startMultiplicity: xStartMulti;
		 endMultiplicity: xEndMulti;
		 yourself! !

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 7/17/2013 12:28'!
nameStart: xNameStart start: xStart end: xEnd endMultiplicity: xEndMulti 
	^ super new initialize nameStart: xNameStart;
		 start: xStart;
		 end: xEnd;
		 endMultiplicity: xEndMulti;
		 yourself! !

!UMLCompositions class methodsFor: 'instance creation' stamp: 'volosmat 7/17/2013 12:32'!
nameStart: xNameStart start: xStart startMultiplicity: xStartMulti  end: xEnd endMultiplicity: xEndMulti 
	^ super new initialize nameStart: xNameStart;
		 start: xStart;
		 end: xEnd;
		 endMultiplicity: xEndMulti;
		 startMultiplicity: xStartMulti;
		 yourself! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:30'!
end
	^ end! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:30'!
end: anObject
	end := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
endMultiplicity
	^ endMultiplicity! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
endMultiplicity: anObject
	endMultiplicity := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 12:25'!
nameEnd
	^ nameEnd! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 12:26'!
nameEnd: anObject
	nameEnd := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 12:25'!
nameStart
	^ nameStart! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 12:26'!
nameStart: anObject
	nameStart := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 7/17/2013 12:26'!
start
	^start! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
start: anObject
	start := anObject! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
startMultiplicity
	^ startMultiplicity! !

!UMLCompositions methodsFor: 'accessing' stamp: 'volosmat 5/9/2013 20:31'!
startMultiplicity: anObject
	startMultiplicity := anObject! !

Object subclass: #UMLElement
	instanceVariableNames: 'attributs methods compositions parent name abstract disjoint XOR'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 15:24'!
name: xName

	^(super new initialize)
		name: xName;
		parent: nil;
		disjoint: nil;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:41'!
name: xName abstract: xAbstract

	^(super new initialize)
		name: xName;
		abstract: xAbstract;
		parent: nil;
		disjoint: nil;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:44'!
name: xName parent: xParent

	^(super new initialize)
		name: xName;
		parent: xParent;
		disjoint: true;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:44'!
name: xName parent: xParent abstract: xAbstract

	^(super new initialize)
		name: xName;
		parent: xParent;
		abstract: xAbstract;
		disjoint: true;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'volosmat 7/16/2013 14:45'!
name: xName parent: xParent abstract: xAbstract disjoint: xDisjoint

	^(super new initialize)
		name: xName;
		parent: xParent;
		abstract: xAbstract;
		disjoint: xDisjoint;
		yourself! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 11:13'!
XOR
	^ XOR! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 11:14'!
XOR: anObject
	XOR := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:35'!
abstract
	^ abstract! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:35'!
abstract: anObject
	abstract := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 23:57'!
attributes
	^ attributs! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 12/11/2013 23:58'!
attributes: anObject
	attributs := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
compositions
	^ compositions! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
compositions: anObject
	compositions := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:35'!
disjoint
	^ disjoint! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:35'!
disjoint: anObject
	disjoint := anObject! !

!UMLElement methodsFor: 'initialize-release' stamp: 'volosmat 7/16/2013 14:42'!
initialize
	"set numbers of used classes and relations to empty"

	attributs := OrderedCollection new.
	methods := OrderedCollection new.
	compositions := OrderedCollection new.
	XOR := OrderedCollection new.
	abstract := false.
	disjoint  := true.
	^ self! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
methods
	^ methods! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
methods: anObject
	methods := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
name
	^ name! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
name: anObject
	name := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
parent
	^ parent! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 5/10/2013 10:46'!
parent: anObject
	parent := anObject.
	isDisjoint := true.
! !

!UMLElement methodsFor: 'accessing' stamp: 'volosmat 7/16/2013 14:36'!
parent: anObject disjoint: xDisjoint
	parent := anObject.
	disjoint := xDisjoint.
! !
